/*
 * TestServlet.java
 * 
 * Version:
 *  $Id$
 *
 * Revision: $Revision$ 
 *
 * Log: $Log$
*/
package com.actual_systems.web.test;


import com.actual_systems.test.TestSession;
import org.jboss.security.client.SecurityClient;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.security.auth.login.LoginException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

public class TestServlet extends HttpServlet {

    @Override
    protected void doPost(final HttpServletRequest httpServletRequest, final HttpServletResponse httpServletResponse) throws ServletException, IOException {
        doGet(httpServletRequest, httpServletResponse);
    }

    @Override
    public void doGet(final HttpServletRequest request, final HttpServletResponse httpServletResponse) throws ServletException, IOException {

        String sendMessage = request.getParameter("sendMessage");
        System.out.println("TestServlet: doGet called with sendMessage = " + sendMessage);

        TestSession testSession;
        SecurityClient client = null;
        try {
            client = JAASHelper_s.login("client-login", "testrobert", "robert");

            testSession = (TestSession) new InitialContext().lookup("javaEEApplication/TestSessionEJB/remote");
        } catch (NamingException e) {
            throw new RuntimeException(e);
        } catch (LoginException e) {
            throw new RuntimeException(e);
        }

        //call to session bean
        System.out.println("TestServlet : doGet() : calling session bean.");
        testSession.runTest();

        if("true".equals(sendMessage)){
            sendMessageToQueue();
            try {
                System.out.println("TestServlet : doGet() : Waiting for 2 sec :  start");
                Thread.sleep(2000);
                System.out.println("TestServlet : doGet() : Waiting for 2 sec :  end");
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }

        testSession.runTest();

        final PrintWriter writer = httpServletResponse.getWriter();
        writer.write("<XML> ");
        writer.write("LOGIN SUCCESSFULL 1 \n");
        writer.write("request.getUserPrincipal().getName() = " + request.getUserPrincipal());
        writer.write("</XML> ");

        writer.flush();

        client.logout();


    }

    private void sendMessageToQueue() {
        InitialContext context = null;
        Connection conn = null;
        try {
            context = new InitialContext();
            ConnectionFactory connectionFactory = (ConnectionFactory) context.lookup("java:/JmsXA");
            conn = connectionFactory.createConnection();

            Session session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);

            Queue queue = (Queue) context.lookup("queue/TestHornetQueue");
            System.out.println("queue.getQueueName() = " + queue.getQueueName());

            MessageProducer producer = session.createProducer(queue);
            ObjectMessage message = session.createObjectMessage("Test Message created");

            System.out.println("TestServlet : doGet() : message sent to the TestHornetQueue");
            producer.send(message);
        } catch (NamingException e) {
            throw new RuntimeException(e);
        } catch (JMSException e) {
            throw new RuntimeException(e);
        } finally {
            try {
                conn.close();
            } catch (JMSException e) {
                throw new RuntimeException(e);
            }
        }
    }

}
