/*
 * TestMDB.java
 * 
 * Version:
 *  $Id$
 *
 * Revision: $Revision$ 
 *
 * Log: $Log$
*/
package com.actual_systems.test;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

/**
 * TODO - Add file description
 *
 * @author TODO
 * @version $Revision$
 */

@MessageDriven(name = "TestMDB",
        activationConfig = {
                @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
                @ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/TestHornetQueue"),
                @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "1"),
                @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "NonDurable"),
                @ActivationConfigProperty(propertyName = "DLQMaxResent", propertyValue = "0") //  // Prevent retransmits, just put failed messages into DLQ
        }
)
@org.jboss.ejb3.annotation.ResourceAdapter("hornetq-ra.rar")

public class TestMDB implements MessageListener {

    @Resource
    MessageDrivenContext context;

    public void onMessage(final Message message) {
        System.out.println("TestMDB : onMessage() : started");

        try {
            ObjectMessage objectMessage = (ObjectMessage) message;
            System.out.println("TestMDB : onMessage() : message = " + objectMessage.getObject());
        } catch (JMSException e) {
            System.out.println("TestMDB : onMessage() : ERROR OCCURRED");
            throw new RuntimeException(e);
        }
    }
}
